/*
 * @Author: 陈伟亮 1186723967@qq.com
 * @Date: 2019-07-05 16:20:40
 * @LastEditors: chenkangxu
 * @LastEditTime: 2022-08-24 17:28:10
 * @FilePath: \background-front-end\static\plugins\tinymce\plugins\lineheight\plugin.min.js
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
// import { Loading } from 'element-ui';
tinymce.PluginManager.add('lineheightcustom', function(editor, url) {
    var pluginName='设置行高';
    var global$1 = tinymce.util.Tools.resolve('tinymce.util.Tools');
    var lineheight_val = editor.getParam('lineheight_val', '1 1.5 1.6 1.75 1.8 2 3 4 5');
    var selector='p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li,table'
    editor.on('init', function() {
        editor.formatter.register({
            lineheight: {
                selector ,
                styles: { 'line-height': '%value' }
            }
        });
        doAct(1.75)
    });
    editor.on('PastePostprocess', function(args) {
        // const loadingInstance = Loading.service({
        //   fullscreen: true,
        //   lock: true,
        //   text: '正在粘贴文章内容,请稍候~',
        //   spinner: 'el-icon-loading',
        //   background: 'rgba(0, 0, 0, 0.7)'
        // })
        function setLineHeight(node){
            // console.log(node.tagName.toLowerCase())
            if(selector.indexOf(node.tagName.toLowerCase())!=-1){
                doAct(1.75,node)
            }
            for(let i=0;i<node.children.length;i++){
                setLineHeight(node.children[i])
            }
        }   
        setLineHeight(args.node)
        // loadingInstance.close();
    });
    var doAct = function (value,node) {
        editor.formatter.apply('lineheight', { value: value },node);
        editor.fire('change', {});
    };

    editor.ui.registry.getAll().icons.lineheight || editor.ui.registry.addIcon('lineheight','<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M9.984 12.984v-1.969h12v1.969h-12zM9.984 18.984v-1.969h12v1.969h-12zM9.984 5.016h12v1.969h-12v-1.969zM6 6.984v10.031h2.484l-3.469 3.469-3.516-3.469h2.484v-10.031h-2.484l3.516-3.469 3.469 3.469h-2.484z"></path></svg>');
    
    editor.ui.registry.addMenuButton('lineheightcustom', {
        icon: 'lineheight',
        tooltip: pluginName,
        fetch: function(callback) {
            var dom = editor.dom;
            var blocks = editor.selection.getSelectedBlocks();
            var lhv = 0;
            global$1.each(blocks, function(block) {
                if(lhv==0){
                    lhv = dom.getStyle(block,'line-height') ? dom.getStyle(block,'line-height') : 0;
                }
            });

            var items = lineheight_val.split(' ').map(function(item){
                var text = item;
                var value = item;
                return {
                    type: 'togglemenuitem',
                    text: text,
                    active : lhv==value ? true :false,
                    onAction: function() {
                        doAct(value);
                    }
                };
            });
            callback(items);
        }
    });

    return {
        getMetadata: function () {
            return  {
                name: pluginName,
                url: "http://tinymce.ax-z.cn/more-plugins/lineheight.php",
            };
        }
    };
});
