/*
 * @Author: 陈伟亮 1186723967@qq.com
 * @Date: 2020-09-02 10:01:22
 * @LastEditors: 陈伟亮 1186723967@qq.com
 * @LastEditTime: 2022-08-06 16:50:48
 * @FilePath: \background-front-end\static\plugins\tinymce\plugins\wlindent\plugin.min.js
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
tinymce.PluginManager.add("wlindent", function(editor, url) {
  editor.ui.registry.addMenuButton("wlindent", {
    icon: "indent",
    tooltip: "边距",
    fetch: function(callback) {
      var dom = editor.dom;
      var blocks = editor.selection.getSelectedBlocks();
      //设置按钮能否可点


      function add(name) {
        blocks.map(function(block) {
          var pl = dom.getStyle(block, "padding-left");
          var pr = dom.getStyle(block, "padding-right");
          var numl = isNaN(parseFloat(pl)) ? 0 : parseFloat(pl);
          var numr = isNaN(parseFloat(pr)) ? 0 : parseFloat(pr);
          numl
            ? dom.setStyle(
                block,
                name + "-left",
                numl + 20 + pl.replace(numl, "")
              )
            : dom.setStyle(block, name + "-left", numl + 20 + "px");
          numr
            ? dom.setStyle(
                block,
                name + "-right",
                numr + 20 + pr.replace(numr, "")
              )
            : dom.setStyle(block, name + "-right", numr + 20 + "px");
        });
      }
      function substr(name) {
        blocks.map(function(block) {
          var pl = dom.getStyle(block, "padding-left");
          var pr = dom.getStyle(block, "padding-right");
          var numl = isNaN(parseFloat(pl)) ? 0 : parseFloat(pl);
          var numr = isNaN(parseFloat(pr)) ? 0 : parseFloat(pr);
          if (pl) {
            if ((isNaN(numl) ? 0 : numl) - 20 >= 0) {
              dom.setStyle(
                block,
                name + "-left",
                (isNaN(numl) ? 0 : numl) - 20 + pl.replace(numl, "")
              );
            } else {
              dom.setStyle(block, name + "-left", "");
            }
          }
          if (pr) {
            if ((isNaN(numr) ? 0 : numr) - 20 >= 0) {
              dom.setStyle(
                block,
                name + "-right",
                (isNaN(numr) ? 0 : numr) - 20 + pr.replace(numr, "")
              );
            } else {
              dom.setStyle(block, name + "-right", "");
            }
          }
        });
      }
      var items = [
        {
          type: "menuitem",
          text: "增加内边距",
          onAction: function(){
            add("padding")
          }
        },
        {
          type: "menuitem",
          text: "减少内边距",
          onAction: function(){
            substr("padding")
          }
        },
        {
          type: "menuitem",
          text: "增加外边距",
          onAction:function(){
            add("margin")
          } 
        },
        {
          type: "menuitem",
          text: "减少外边距",
          onAction: function(){
            substr("margin")
          }
        }
      ];
      callback(items);
    }
  });
});
